<?php
if(!class_exists("EC_EventILList")) :
class EC_EventILList {
  var $db;
  function EC_EventILList() {
    $this->db = new EC_DB();
  }
  /**
  * Displays the Event ILayer List, WITH recc events, widget ready or not
  */
  function displayEventILList($sens = NULL, $brange = NULL) {
    $first_event_date = $this->db->getFirstEventDate();
    if (!$first_event_date) {
      echo '<ul><li id="no-events-in-list"><strong>', __('Events are coming soon, stay tuned!','events-calendar') , '</strong></li></ul>';
      return;
    }
    global $current_user, $ec_WeekdayNames;
    $options = get_option('optionsEventsCalendar');
    $format = $options['dateFormatLarge'];
    $woptions = get_option('widgetEventsCalendar');
    $ecil_width = $woptions['ILlistWidth'];
    $ecil_height = $woptions['ILlistHeight'];
    $script = "script";
		$day_name_length = $options['daynamelength'];
		$last_event_date = $this->db->getLastEventDate();
		if (is_null($sens)) {
		  $brange = "2008-12-01"; //date('Y-m-d');
		  $erange = date('Y-m-d', strtotime("+100 days", strtotime($brange))); // Must be an option !
    } else {
      if ($sens == "up") {
        do {          
          $brange = date('Y-m-d', strtotime("-101 days", strtotime($brange))); // Must be an option !
          if ($brange < $first_event_date) $brange = $first_event_date;
          $erange = date('Y-m-d', strtotime("+100 days", strtotime($brange))); // Must be an option !
          $testrange = $this->db->getUpcomingILEvents($brange, $erange);
          //echo "brange = $brange, erange = $erange test = $testrange <br />";
          if (!$testrange && $brange == $first_event_date) {
            $testrange = $this->db->getListEvents($first_event_date, 50, true);
            $erange = $testrange[(count($testrange))-1]->eventStartDate;
            break;
          }
        } while (!$testrange);        
      } else {
        do {
          $brange = date('Y-m-d', strtotime("+1 day", strtotime($brange)));
          if ($brange > $last_event_date) $brange = date('Y-m-d', strtotime("-100 days", strtotime($last_event_date)));
          $erange = date('Y-m-d', strtotime("+100 days", strtotime($brange))); // Must be an option !
          if ($erange > $last_event_date) $erange = $last_event_date;
          $testrange = $this->db->getUpcomingILEvents($brange, $erange);
          //echo "brange = $brange, erange = $erange test = $testrange <br />";          
          if (!$testrange && $erange == $last_event_date) {
            $testrange = $this->db->getPrevEvents($last_event_date, 50, '=', true);
            $brange = $testrange[0]->eventStartDate;
            break;
          }
        } while (!$testrange);        
      }
    }    
    $events = array();
    $output = '<div id="events-calendar-il-list"><div id="eciltoplbar"><span id="ecilrwbutt"></span><span id="ecilbutup"></span></div><div id="eciltoprbar"><span id="ecilflbutt"></span><span id="eciltdbutt"></span></div>';    
    $output .= "\n<div id=\"ilcontainer\" style=\"margin:20px 0 4px;padding:0;position:relative;height:".$ecil_height."px;border:none;overflow:scroll;overflow-x:hidden;left:0;top:0;\">";
    $output .= "\n<span id=\"ilcontent\"  style=\"position:absolute;z-index:0;left:0;top:0;\">";
    $output .= "\n<ilayer name=\"nscontainer\" height=".$ecil_height." width=".$ecil_width.">\n<layer name=\"nscontent\" height=".$ecil_height." visibility=hidden>";
    $output .= "\n<ul id=\"uilcontainer\">\n";
    $tmpcount = 0; $sqldate = $brange;
    if ($brange == $first_event_date && $testrange) $output .= '<li id="events-calendar-il-list-start"><blink><strong>'._c('Start of events','events-calendar')."</blink></strong></li>\n";
    while ($sqldate <= $erange) :
      foreach($this->db->getDaysEvents($sqldate) as $e) {
        if ($e->accessLevel == 'public' || current_user_can($e->accessLevel)) {
          $recurrStatus = isset($e->eventRecStatus) ? $e->eventRecStatus : '';
          $recStatusFlag = $recurrStatus ;
          $recProces = $e->eventRecProces;
          $recExcept = $e->eventExceptions;
          $startDate = isset($e->eventStartDate) ? $e->eventStartDate : '';
          if ($recurrStatus && $startDate) $recurrStatus = reccurEventokToDisplay($sqldate, $startDate, $recurrStatus, $recProces, $recExcept);
          if (!$recurrStatus) {
            list($year, $month, $day) = explode('-', $sqldate);
    				$timeStp = mktime(0, 0, 0, $month, $day, $year);
            $startDate = date("$format", $timeStp );
  		  		$day_names = $ec_WeekdayNames[intval(date('w', $timeStp ))];
  			   	if($day_name_length) $day_names = $day_name_length < 4 ? ec_utf8_substr($day_names,0,$day_name_length) : $day_names;
    			  $titlinked = '<strong>'.$day_names.' '.$startDate.'</strong>: '.stripslashes($e->eventTitle);
            $output .= '<li id="events-calendar-il-list-'.$tmpcount++.'">'.$titlinked."</li>\n";
            $e->sqlDate = $sqldate;
            if ($recStatusFlag > 0) $e->eventRecc = 'yes';
            else $e->eventRecc = 'no';
            $events[] = $e;
          }
        }
      }
      $sqldate = date('Y-m-d', strtotime("+1 day", strtotime($sqldate)));
    endwhile;
		if ($tmpcount==0) {
			echo '<ul><li id="no-events-in-list"><strong>', __('Events are coming soon, stay tuned!','events-calendar') , '</strong></li></ul>';
		} else {
        $ecl_frange = $events[0]->sqlDate;
        $ecl_lrange = $events[(count($events))-1]->sqlDate;
		    if ($erange == $last_event_date) $output .= '<li id="events-calendar-il-list-end"><strong><blink>'._c('End of events','events-calendar')."</blink></strong></li>\n";		    
		    $output .= "</ul>\n</layer>\n</ilayer>\n</span>\n</div>\n";
        $output .= "<script language='JavaScript1.2'>\n";
		    echo $output;
?>
  var speed=5  
  var crossobj=document.getElementById? document.getElementById("ilcontent") : document.all.ilcontent
  var contentheight=crossobj.offsetHeight
  
  function movedown(){
    if (parseInt(crossobj.style.top)>=(contentheight*(-1)+100))
      crossobj.style.top=parseInt(crossobj.style.top)-speed+"px"
    movedownvar=setTimeout("movedown()",20)
  }
  
  function moveup(){
    if (parseInt(crossobj.style.top)<=0)
      crossobj.style.top=parseInt(crossobj.style.top)+speed+"px"
    moveupvar=setTimeout("moveup()",20)
  }
  
  function getcontent_height(){
      contentheight=crossobj.offsetHeight
  }
</script>
<div id="ecilbtmrbar"><span id="ecilbutdn"></span><span id="ecilffbutt"></span></div><div id="ecilbtmlbar"><span id="ecilloader"></span><span id="ecilblank"></span></div>
<?php
    		$img_rwecl = EVENTSCALENDARIMAGESURL.'/eclistrw.gif';
        $img_ffecl = EVENTSCALENDARIMAGESURL.'/eclistff.gif';
        $img_mnecl = EVENTSCALENDARIMAGESURL.'/eclistmn.gif';
        $img_plecl = EVENTSCALENDARIMAGESURL.'/eclistpl.gif';
        $img_loadr = EVENTSCALENDARIMAGESURL.'/ajax-loader.gif';
        $img_blank = EVENTSCALENDARIMAGESURL.'/blank.gif';
        echo "<$script type='text/javascript'>\n";
?>
// <![CDATA[
      tb_pathToImage = "<?php echo get_bloginfo('wpurl').'/wp-includes';?>/js/thickbox/loadingAnimation.gif";
      tb_closeImage = "<?php echo get_bloginfo('wpurl').'/wp-includes';?>/js/thickbox/tb-close.png";
      jQuery.noConflict();
      (function($) {
        function ecl_navilist(ilsens,ildate) {
          ecd.jq('#ecilloader').empty();
          ecd.jq('#ecilloader').append('<img src="<?php echo $img_loadr;?>" style="width:16px;"/>');
          ecd.jq.get("<?php bloginfo('wpurl');?>/index.php?",
            {EC_action: 'navigILList', EC_sens: ilsens, EC_date: ildate},
          function(data) {
            ecd.jq('#events-calendar-il-list').empty();
            ecd.jq('#events-calendar-il-list').append(ecd.jq(data).html());
          });          
        }
        ecd.jq(document).ready(function() {
          getcontent_height();
          ecd.jq('#events-calendar-il-list').css('width','<?php echo $ecil_width;?>px');
          ecd.jq('#ecilrwbutt').append('<img src="<?php echo $img_rwecl;?>" style="width:16px;"/>');

          ecd.jq('#ecilffbutt').append('<img src="<?php echo $img_ffecl;?>" style="width:16px;"/>');
          
          ecd.jq('#ecilflbutt').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
          ecd.jq('#eciltdbutt').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
          ecd.jq('#ecilloader').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
          ecd.jq('#ecilblank').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
          ecd.jq('#ecilrwbutt').attr('title', '<?php echo $num." ";_e("Previous range","events-calendar");?>');          
          ecd.jq('#ecilffbutt').attr('title', '<?php echo $num." ";_e("Next range","events-calendar");?>');
          ecd.jq('#ecilrwbutt').tooltip({track: true, delay: 0, fade: 250, top: -30, extraClass: "gotomonth"});
          ecd.jq('#ecilffbutt').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
          ecd.jq('#ecilrwbutt').click(function() {
            ecl_navilist(<?php echo "'up'";?>,<?php echo "'$ecl_frange'";?>);
          });
          ecd.jq('#ecilffbutt').click(function() {
            ecl_navilist(<?php echo "'dn'";?>,<?php echo "'$ecl_lrange'";?>);
          });
<?php
        $this->listData($events);
        echo "   });\n  })(jQuery);\n//]]>\n</script>\n</div>\n";
		}
  }
  /**
  * Displays the Event List, widget ready or not
  */
  function listData($events) {
    global $current_user;
    $options = get_option('optionsEventsCalendar');
    $format = $options['dateFormatLarge'];
    $tmpcount = 0;
    foreach($events as $e):
      $output = '';
      if($e->accessLevel == 'public' || current_user_can($e->accessLevel)) {
        $id = $tmpcount++;
        list($year, $month, $day) = explode('-', $e->eventStartDate);
        $title = $e->eventTitle;
        $description = preg_replace('#\r?\n#', '<br />', $e->eventDescription);
        $location = isset($e->eventLocation) && !empty($e->eventLocation) ? $e->eventLocation : '';
        list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $e->eventStartDate);
          if(!is_null($e->eventStartTime) && !empty($e->eventStartTime)) {
            list($ec_starthour, $ec_startminute, $ec_startsecond) = explode(":", $e->eventStartTime);
            $startTime = date($options['timeFormatLarge'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear));
          } else $startTime = null;
          $startDate = date($options['dateFormatLarge'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear));
          list($ec_endyear, $ec_endmonth, $ec_endday) = split('-', $e->eventEndDate);
          if($e->eventEndTime != null && !empty($e->eventEndTime)) {
            list($ec_endhour, $ec_endminute, $ec_endsecond) = split(":", $e->eventEndTime);
            $endTime = date($options['timeFormatLarge'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear));
          } else $endTime = null;
          $endDate = date($options['dateFormatLarge'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear));
        $accessLevel = $e->accessLevel;
        $output .= "<li><strong>$title</strong></li>";
        if(!empty($location) && !is_null($location))
          $output .= "<dd>$location</dd>";
        if (($startDate != $endDate) && ($endDate > $sqldate)) {
          $output .= '<dd>'.__('Until','events-calendar').': '.date($options['dateFormatWidget'], mktime(0, 0, 0, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
        }
        if (!is_null($startTime) && ($startTime!='')) {
          if (!is_null($endTime) && ($endTime!='')) {
            list($ec_endhour, $ec_endminute, $ec_endsecond) = explode(":", $endTime);
            $output .= '<dd>'.$startTime.' '.__('to','events-calendar').' '.date($options['timeFormatWidget'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
          } else $output .= '<dd>'.__('at','events-calendar').' '.$startTime.'</dd>';
        }
      }
      if($output != ''):
        list($dsy, $dsm, $dsd) = explode('-', $e->sqlDate);
        $date_show = get_tbdate_show($dsd, $dsm, $dsy);
          ?>
           ecd.jq('#events-calendar-il-list-<?php echo $id;?>').attr('title', '<?php echo $output;?>');
           ecd.jq('#events-calendar-il-list-<?php echo $id;?>').mouseover(function() { ecd.jq(this).css('cursor', 'pointer');});
           ecd.jq('#events-calendar-il-list-<?php echo $id;?>').tooltip({delay:0, track:true});
           ecd.jq('#events-calendar-il-list-<?php echo $id;?>').click(function() {
               tb_show("<?php echo $date_show; ?>", "<?php bloginfo('wpurl');?>?EC_view=day&EC_month=<?php echo $month;?>&EC_day=<?php echo $day;?>&EC_year=<?php echo $year;?>&EC_recc=<?php echo $e->eventRecc;?>&TB_iframe=true&width=220&height=250", false);
           });
          <?php
      endif;
    endforeach;
 }
}
endif;
?>