<?php
if(!class_exists("EC_EventList")) :
class EC_EventList {
  var $db;
  function EC_EventList() {
    $this->db = new EC_DB();
  }
  /**
  * Displays the Event List, basic : without recc events, widget ready or not
  */
  function displayEventList($num, $incr = NULL, $sens = NULL, $d = NULL) {
    $first_event_date = $this->db->getFirstEventDate(false);
    if (!$first_event_date) {
      echo '<ul><li id="no-events-in-list"><strong>', __('Events are coming soon, stay tuned!','events-calendar') , '</strong></li></ul>';
      return;    
    }
    global $current_user, $ec_WeekdayNames;
    $options = get_option('optionsEventsCalendar');
    $format = $options['dateFormatLarge'];
		$day_name_length = $options['daynamelength'];
		$last_event_date = $this->db->getLastEventDate(false);
		if (is_null($d)) {
		  $d = date('Y-m-d');
      $events = $this->db->getUpcomingEvents($num, $d);
    } else {
      if ($sens == "up") {
        if ($incr == 1) {
          $events = $this->db->getPrevEvents($d, 1);
          if (count($events) > 0) $d = $events[0]->eventStartDate;
          $events = $this->db->getListEvents($d, $num);
        } else {
          $events = $this->db->getPrevEvents($d, $num);
          $d = $events[0]->eventStartDate;
          $events = $this->db->getListEvents($d, $num);
        }
      } else {
          $dtmp = $d; $events = $this->db->getNextEvents($d, $num);
          if ($incr == 1) {
            $d = $events[0]->eventStartDate; if (!$d) $d = $dtmp;
            $events = $this->db->getPrevEvents($d, $num, "=");
          } else {
            if (count($events) > $num) {
              $d = $events[0]->eventStartDate;
              $events = $this->db->getListEvents($d, $num);
            } else $events = $this->db->getPrevEvents($last_event_date, $num, "=");
          }
      }
    }
    //echo date("Y-m-d", strtotime("last year -10 days"));
    if (!$events[0]->eventStartDate) {      
      do {
        $d = date("Y-m-d", strtotime("last week", strtotime($d)));
        if ($d < $first_event_date) break;
        $events = $this->db->getUpcomingEvents($num, $d, false); 
        // echo "$d\n";
        }        
      while (!$events[0]->eventStartDate);
      if ((count($events)+1 < $num) && (count($events) > 0)) {
        $d = $events[(count($events))-1]->eventStartDate;
        $events = $this->db->getPrevEvents($d, $num, "=", false);
      }      
    }
    $ecl_fdate = $events[0]->eventStartDate;
    $ecl_ldate = $events[(count($events))-1]->eventStartDate;
    $output = '<div id="events-calendar-list"><div id="ecltoplbar"><span id="eclrwbutt"></span><span id="eclbuttm"></span></div><div id="ecltoprbar"><span id="eclflbutt"></span><span id="ecltdbutt"></span></div><ul id="events-calendar-ullist">'."\n\t";
    $tmpcount = 0;
    // echo var_dump($events);
    if ($events && $ecl_fdate == $first_event_date) $output .= '<li id="events-calendar-il-list-start"><blink><strong>'._c('Start of events','events-calendar')."</blink></strong></li>\n";
    foreach($events as $event) {
      if ($event->accessLevel == 'public' || current_user_can($event->accessLevel)) {
        list($year, $month, $day) = explode('-', $event->eventStartDate);
				$timeStp = mktime(0, 0, 0, $month, $day, $year);
        $startDate = date("$format", $timeStp );
				$day_names = $ec_WeekdayNames[intval(date('w', $timeStp ))];
				if($day_name_length) $day_names = $day_name_length < 4 ? ec_utf8_substr($day_names,0,$day_name_length) : $day_names;
  			$titlinked = '<strong>'.$day_names.' '.$startDate.'</strong>: '.stripslashes($event->eventTitle);
        $output .= '<li id="events-calendar-list-'.$event->id.'">'.$titlinked."</li>\n";
        $tmpcount++;
      }
    }
    if ($ecl_ldate == $last_event_date) $output .= '<li id="events-calendar-il-list-start"><blink><strong>'._c('End of events','events-calendar')."</blink></strong></li>\n";
    $output .= '</ul><div id="eclbtmrbar"><span id="eclbuttp"></span><span id="eclffbutt"></span></div><div id="eclbtmlbar"><span id="eclloader"></span><span id="eclblank"></span></div>'."\n";
		if ($tmpcount==0) {
			echo '<ul><li id="no-events-in-list"><strong>', __('Events are coming soon, stay tuned!','events-calendar') , '</strong></li></ul>';
		} else {
    		$img_rwecl = EVENTSCALENDARIMAGESURL.'/eclistrw.gif';
        $img_ffecl = EVENTSCALENDARIMAGESURL.'/eclistff.gif';
        $img_mnecl = EVENTSCALENDARIMAGESURL.'/eclistmn.gif';
        $img_plecl = EVENTSCALENDARIMAGESURL.'/eclistpl.gif';
        $img_loadr = EVENTSCALENDARIMAGESURL.'/ajax-loader.gif';
        $img_blank = EVENTSCALENDARIMAGESURL.'/blank.gif';
        $output .= "\n".'<script type="text/javascript">'."\n".'// <![CDATA['."\n";
        echo $output;
        ?>
              tb_pathToImage = "<?php echo get_bloginfo('wpurl').'/wp-includes';?>/js/thickbox/loadingAnimation.gif";
              tb_closeImage = "<?php echo get_bloginfo('wpurl').'/wp-includes';?>/js/thickbox/tb-close.png";
              jQuery.noConflict();
              (function($) {
                ecd.jq(document).ready(function() {
                  function ecl_navlist(nincr,nsens,ndate) {
                    ecd.jq('#eclloader').empty();
                    ecd.jq('#eclloader').append('<img src="<?php echo $img_loadr;?>" style="width:16px;"/>');
                    ecd.jq.get("<?php bloginfo('wpurl');?>/index.php?",
                    {EC_action: 'navigList', EC_num: <?php echo $num;?>, EC_incr: nincr, EC_sens: nsens, EC_date: ndate},
                    function(data) {
                      ecd.jq('#events-calendar-list').empty();
                      ecd.jq('#events-calendar-list').append(ecd.jq(data).html());
                    });
                  }
                  ecd.jq('#eclrwbutt').append('<img src="<?php echo $img_rwecl;?>" style="width:16px;"/>');
                  ecd.jq('#eclbuttm').append('<img src="<?php echo $img_mnecl;?>" style="width:16px;"/>');
                  ecd.jq('#eclffbutt').append('<img src="<?php echo $img_ffecl;?>" style="width:16px;"/>');
                  ecd.jq('#eclbuttp').append('<img src="<?php echo $img_plecl;?>" style="width:16px;"/>');
                  ecd.jq('#eclflbutt').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
                  ecd.jq('#ecltdbutt').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
                  ecd.jq('#eclloader').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
                  ecd.jq('#eclblank').append('<img src="<?php echo $img_blank;?>" style="width:16px;"/>');
                  ecd.jq('#eclrwbutt').attr('title', '<?php echo $num." ";_e("previous events","events-calendar");?>');
                  ecd.jq('#eclbuttm').attr('title', '<?php _e("Previous event","events-calendar");?>');
                  ecd.jq('#eclffbutt').attr('title', '<?php echo $num." ";_e("next events","events-calendar");?>');
                  ecd.jq('#eclbuttp').attr('title', '<?php _e("Next event","events-calendar");?>');
                  ecd.jq('#eclrwbutt').tooltip({track: true, delay: 0, fade: 250, top: -30, extraClass: "gotomonth"});
                  ecd.jq('#eclbuttm').tooltip({track: true, delay: 0, fade: 250, top: -30, extraClass: "gotomonth"});
                  ecd.jq('#eclffbutt').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
                  ecd.jq('#eclbuttp').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
                  ecd.jq('#eclrwbutt').click(function() {
                    ecl_navlist(<?php echo $num;?>,<?php echo "'up'";?>,<?php echo "'$ecl_fdate'";?>);
                  });
                  ecd.jq('#eclffbutt').click(function() {
                    ecl_navlist(<?php echo $num;?>,<?php echo "'dn'";?>,<?php echo "'$ecl_ldate'";?>);
                  });
                  ecd.jq('#eclbuttm').click(function() {
                    ecl_navlist(1,<?php echo "'up'";?>,<?php echo "'$ecl_fdate'";?>);
                  });
                  ecd.jq('#eclbuttp').click(function() {
                    ecl_navlist(1,<?php echo "'dn'";?>,<?php echo "'$ecl_ldate'";?>);
                  });
      		<?php
			$this->listData($events);
      echo '   });'."\n".'  })(jQuery);'."\n".'//]]>'."\n".'</script></div>'."\n";
		}
  }
  /**
  * Displays the Event List, widget ready or not
  */
  function listData($events) {
    global $current_user;
    $options = get_option('optionsEventsCalendar');
    $format = $options['dateFormatLarge'];
    foreach($events as $e):
    $output = '';
    if($e->accessLevel == 'public' || current_user_can($e->accessLevel)) {
      $id = "$e->id";      
      $splitDate = explode('-', $e->eventStartDate);
      $month = $splitDate[1]; $day = $splitDate[2]; $year = $splitDate[0];      
      $title = $e->eventTitle;
      $description = preg_replace('#\r?\n#', '<br />', $e->eventDescription);
      $location = isset($e->eventLocation) && !empty($e->eventLocation) ? $e->eventLocation : '';
      list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $e->eventStartDate);
        if(!is_null($e->eventStartTime) && !empty($e->eventStartTime)) {
          list($ec_starthour, $ec_startminute, $ec_startsecond) = explode(":", $e->eventStartTime);
          $startTime = date($options['timeFormatLarge'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear));
        } else $startTime = null;
        $startDate = date($options['dateFormatLarge'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear));
        list($ec_endyear, $ec_endmonth, $ec_endday) = split('-', $e->eventEndDate);
        if($e->eventEndTime != null && !empty($e->eventEndTime)) {
          list($ec_endhour, $ec_endminute, $ec_endsecond) = split(":", $e->eventEndTime);
          $endTime = date($options['timeFormatLarge'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear));
        } else $endTime = null;
        $endDate = date($options['dateFormatLarge'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear));
      $accessLevel = $e->accessLevel;
      $output .= "<li><strong>$title</strong></li>";
      if(!empty($location) && !is_null($location))
        $output .= "<dd>$location</dd>";
      if (($startDate != $endDate) && ($endDate > $sqldate)) {
        $output .= '<dd>'.__('Until','events-calendar').': '.date($options['dateFormatWidget'], mktime(0, 0, 0, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
      }
      if (!is_null($startTime) && ($startTime!='')) {
        if (!is_null($endTime) && ($endTime!='')) {
          list($ec_endhour, $ec_endminute, $ec_endsecond) = explode(":", $endTime);
          $output .= '<dd>'.$startTime.' '.__('to','events-calendar').' '.date($options['timeFormatWidget'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
        } else $output .= '<dd>'.__('at','events-calendar').' '.$startTime.'</dd>';
      }
    }
    if($output != ''):          
    $date_show = get_tbdate_show($day, $month, $year);    
    ?>      
      ecd.jq('#events-calendar-list-<?php echo $id;?>').attr('title', '<?php echo $output;?>');
      ecd.jq('#events-calendar-list-<?php echo $id;?>').mouseover(function() {
        ecd.jq(this).css('cursor', 'pointer');
      });
      ecd.jq('#events-calendar-list-<?php echo $e->id;?>').tooltip({
        delay:0,
        track:true
      });
      ecd.jq('#events-calendar-list-<?php echo $id;?>').click(function() {
          tb_show("<?php echo $date_show; ?>", "<?php bloginfo('wpurl');?>?EC_view=day&EC_month=<?php echo $month;?>&EC_day=<?php echo $day;?>&EC_year=<?php echo $year;?>&EC_recc=no?TB_iframe=true&width=220&height=250", false);
      });
    <?php
    endif;
    endforeach;
 }
}
endif;
?>