<?php
/**
* Layout for : Events Management Form
*/
// Local langage code on two chars
global $loc_lang,$ec_WeekdayNames, $ec_WeekdayString;
  // Titles
  define('EC_MANFORM_ADD_TITLE',_c('Add an event','events-calendar'));
  define('EC_MANFORM_UPD_TITLE','<div class="wrap"><h2>'._c('Edit an event','events-calendar').'</h2></div>');
  // Default Link out string
  $this->ecf_deflinkout = "http://";
  // Access Level array
  $this->accessLevel_list = array("public" =>_c('Public','events-calendar'),
                                  "level_10"=>_c('Administrator','events-calendar'),
                                  "level_7" =>_c('Editor','events-calendar'),
                                  "level_2" =>_c('Author','events-calendar'),
                                  "level_1" =>_c('Contributor','events-calendar'),
                                  "level_0" =>_c('Subscriber','events-calendar'));

  $this->custJsHeader = '
var msgOverRange ="'._c('The grid can not accept a number greater\nthan 50 recurrence dates.\nYou can enter a minimum date for a\nsmaller range.','events-calendar').'";
var noShowGridMsg = "'._c('There are no recurrences to show.\n\nPlease check your dates and your recurrence settings','events-calendar').'", RecLinkout = "'._c('Link out','events-calendar').'";
var msgMaxLengthExeptArray = "'._c('Warning: You have reached the maximum number of recordable exceptions!','events-calendar').'", fromVign = "'._c('From','events-calendar').'", toVign = "'._c('to','events-calendar').'";
var chgReccMsg = "'._c('Warning! You change the type of recurrence, while exceptions are recorded.\n\nThis will erase them.\n\n Do you confirm?','events-calendar').'", RecEveryOfMonth = "'._c('Every %s / month','events-calendar').'", RecAnnual = "'._c('Annual','events-calendar').'",
RecEveryXDay = "'._c('Every %s days','events-calendar').'", weekdayString = "'.$ec_WeekdayString.'", RecEvery = "'._c('Every','events-calendar').'", RecLastWeek = "'._c('last','events-calendar').'", RecWeeks = "'._c('Every %s week','events-calendar').'";
var ttCloseMsg = "'._c('Close','events-calendar').'", ttDisabMsg ="'._c("Don\'t show this message again",'events-calendar').'", nothingToDisplay = "'._c('Nothing to display','events-calendar').'", RecDuration = "'._c('Duration','events-calendar').'";
var optDeo = "'.$this->ecopt_ev_deo.'", optMilTime = '.($this->ecopt_ev_miltime?'true':'false').', optRecurr = '.($this->ecopt_ev_recc?'true':'false').', optExcept = '.($this->ecopt_ev_exrec?'true':'false').'; 
var id='.(($id)?$id:'false').',lang ="'.$loc_lang.'", deflinkout ="'.$ecf_deflinkout.'", YesNoGrid = "'._c('Yes:No','events-calendar').'", chkYes, chkNo;
var EVENTSCALENDARJSURL = "'.EVENTSCALENDARJSURL.'", startExcept = '.(isset($_GET['EC_except'])? 'true':'false').';
var tinytr = new Array("'.__('Bold').'","'.__('Italic').'","'.__('Underline').'","'.__('Strikethrough').'","'.__('Align left').'","'.__('Align center').'","'.__('Align right').'","'.__('Align full').'","'.__('Unordered list').'","'.__('Ordered list').'","'.__('Outdent').'","'.__('Indent').'","'.__('Undo').'","'.__('Redo').'");
var fday ='.WPECFDW.', wdn = new Array("'.substr($ec_WeekdayNames[0],0,3).'","'.substr($ec_WeekdayNames[1],0,3).'","'.substr($ec_WeekdayNames[2],0,3).'","'.substr($ec_WeekdayNames[3],0,3).'","'.substr($ec_WeekdayNames[4],0,3).'","'.substr($ec_WeekdayNames[5],0,3).'","'.substr($ec_WeekdayNames[6],0,3).'");
var wkn = new Array("'._c('1st','events-calendar').'","'._c('Sec','events-calendar').'","'._c('Thd','events-calendar').'","'._c('Fth','events-calendar').'","'._c('Last','events-calendar').'");
var ifrm = "'._c('The iFrame code field is empty !','events-calendar').'", every ="'._c('Every','events-calendar').'", otm="'._c('of the month','events-calendar').'",days ="'._c('day(s)','events-calendar').'";
var anev = "'._c('Annual event','events-calendar').'", wks = "'._c('Week(s)','events-calendar').'", toolate = "'._c('Too late !\nCheck the Event End Date please','events-calendar').'";
var EVENTSCALENDARIMAGESURL = "'.EVENTSCALENDARIMAGESURL.'", dpimg = EVENTSCALENDARIMAGESURL+"/calendarlg.gif", dprimg = EVENTSCALENDARIMAGESURL+"/icon_calendar.gif", ttimg = EVENTSCALENDARIMAGESURL+"/ec_tooltips/"; 
var lastsel, gridimgpath = "'.EVENTSCALENDARCSSURL.'/themes/basic/images", excptListCaption = "'._c('Exceptions recurrences list','events-calendar').'";
var pathtojqgridfiles = "'.EVENTSCALENDARURL.'/js/jgrid/", jqgridsomeurl = "'.EVENTSCALENDARURL.'/someurl.php", excpCanCol = "#ff7a7a";
var tpmsg = new Array(
"'._c('Basic Information of the Event: What, When and Where','events-calendar').'",
"'._c('Extended informations. This tab is optional: if you don\'t need, you gain performance by disabling it','events-calendar').'",
"'._c('Please select the mode of recurrence you want for this event.','events-calendar').'",
"'._c('Declare here the exceptions of recurrences. Warning: you are limited to 50 exceptions!','events-calendar').'"
);
';

  function ecly_manform_js_sm_script($id) {
    $output = '<script type="text/javascript" src="'.EVENTSCALENDARJSURL.'/ec-form.js"></script>
<script type="text/javascript" src="'.EVENTSCALENDARJSURL.'/ec-manevent.js"></script>
';
    if($id) $output .= '<script type="text/javascript" src="'.EVENTSCALENDARJSURL.'/ec-formupd.js"></script>
';
    else $output .= '<script type="text/javascript" src="'.EVENTSCALENDARJSURL.'/ec-formadd.js"></script>
';
    return $output;
  }

  $this->ecly_custResetAction = '
              // Specific to the box event form : hide the reccurence tab, reset recc form and click on event form tab
              jQuery("#item0").trigger("click");
              if(!formObj.EC_reccStatus.checked) jQuery("#item2").hide(); else restoreReccChk();
              if(!formObj.EC_reccbExcept.checked) jQuery("#item3").hide(); else exceptActualize(false);
              ';
              
  function ecly_manform_head_menu ($title) {
    $output =
      '<div id="ecform_container">
        <div id="ecform_entete">
      	 <span id="ecform_title" class="wrap"><h2>'.$title.'</h2></span>
      	   <ul id="menu">
      	   ';
    return $output;
  }
  $this->ecly_manform_tbar_menu =
      	'</ul>
      </div>
    	<div id="ecform_topbar">
        <div id="left_topbar"></div>
        <div id="center_topbar"></div>
      </div>
      <div id="right_topbar"></div>
    	<div id="ecform_content">
      ';
      
  function ecly_manform_foot_menu($fmode, $year, $month) {  
    $href_add = ($fmode == 'edit')?('&EC_action=switchMonthAdmin&EC_month='.$month.'&EC_year='.$year):''; 
    return '</div>
    <div id="ecform_btmbar">
      <ul id="ecform_buttons">
        <li id="btreset" onClick="javascript:ecformReset();return false;" class="buttons">
          <a alt="Reset">Reset</a>
        </li>
        <li class="buttons">
          <a href="?page=events-calendar-main'.$href_add.'" id="btcancel" alt="cancel">'._c('Cancel','events-calendar').'</a>
        </li>
        <li class="buttons">
          <a id="btsubmit" onClick="if(document.EC_'.$fmode.'EventForm.onsubmit()){eventSubmit(\''.$month.'\',\''.$year.'\')};" alt="submit">'._c('Submit','events-calendar').'</a>
        </li>
      </ul>
    </div>
  </div>
    ';
  }
  $this->ecly_manform_head_ism =
    '<div class="ecform_smenu">
      <ul class="smenu">
      ';
  $this->ecly_manform_foot_ism = '
      </ul>
     </div>
     ';
  function ecfly_countryList($country,$state='') {
    $output =  '<select id="countrySelect" name="EC_country" onchange="populateState(\''.strtoupper($state).'\')"></select>
          <select id="stateSelect" name="EC_state"></select>
          <script type="text/javascript" charset="utf-8" src="'.EVENTSCALENDARJSURL.'/ec_form.country.list.js"></script>
          <script type="text/javascript" charset="utf-8">initCountry("'.strtoupper($country).'","'.strtoupper($state).'","'._c('Select a Country','events-calendar').'","'._c('Select state','events-calendar').'");</script>';
    return $output;
  }
?>