/************************************************************************************************************

	Form field tooltip
	(C) www.dhtmlgoodies.com, September 2006
	www.dhtmlgoodies.com
	Alf Magne Kalleland

	Updated , adapted and (very) improved by Heirem(c) http://heirem.fr

************************************************************************************************************/
var ec_globalTooltipObj;
function ec_formTooltip(){
/*	var tooltipDiv;
	var tooltipText;
	var tooltipContentDiv;	// Reference to inner div with tooltip content
	var imagePath;					// Relative path to images
	var arrImgBtlFile;			// Name of arrow image
	var arrImgRtlFile;			// Name of arrow image
	var arrImgRblFile;	 // Name of arrow image
	var arrImgRtrFile;			// Name of arrow image
	var arrowRightWidth; // Name of arrow image
	var arrImgRbrFile; // Name of arrow image
	var arrowTopHeight; // Heith of arrow
	var tooltipNoMove;     // List of  Ids of content for no move tooltip
	var tooltipWidth;				// Width of tooltip
	var roundedCornerObj;		// Reference to object of class ec_roundedCorners
	var tooltipBgColor;
	var closeMessage;					// Close message
	var activeInput;					// Reference to currently active input
	var tooltipPosition;				// Tooltip position, possible values: "below" or "right"
	var tooltipCornerSize;				 // Size of rounded corners
	var displayArrow;					 // Display arrow above or at the left of the tooltip?
	var cookieName;						 // Name of cookie
	var disableTooltipPossibility;	 // Possibility of disabling tooltip
	var disableTooltipByCookie;		 // If tooltip has been disabled, save the settings in cookie, i.e. for other pages with the same cookie name.
	var disableTooltipMessage;
	var tooltipDisabled;
	var isMSIE;
	var tooltipIframeObj;
	var pageBgColor;					// Color of background - used in ie when applying iframe which covers select boxes
	var currentTooltipObj;		// Reference to form field which tooltip is currently showing for
	var limitedId; // Limited to a area of the document by the Id
	var limitedNode; // Limited to a area of the document by the Node, Class & Tag (node and tag are optionals)
	var limitedClass;
	var limitedTag;
  var offsetfromcursorX; //Customize x offset of tooltip
  var offsetfromcursorY; //Customize y offset of tooltip
  var offsetdivfrompointerX; //Customize x offset of tooltip DIV relative to pointer size
  var offsetdivfrompointerY; //Customize y offset of tooltip DIV relative to pointer size.
  var colorTemplate; // Name of a color template
  var customTemplate; // Custom template ddicaced to one tag : template="color of the template"
*/
  this.limitedId = '';
  this.limitedClass = '';
  this.limitedNode = '';
  this.limitedTag = '';  
  this.offsetfromcursorX = 0;
  this.offsetfromcursorY = 0;
  this.offsetdivfrompointerX = 12;
  this.offsetdivfrompointerY = 27;
	this.currentTooltipObj = false;
	this.tooltipDiv = false;
	this.tooltipText = false;
	this.imagePath = 'images/';
	this.arrImgBtlFile = 'gray-arrow-btl.gif'; // Arrow Below - Top Left
	this.arrImgBblFile = 'gray-arrow-bbl.gif'; // Arrow Below - Below Left
	this.arrImgBtrFile = 'gray-arrow-btr.gif'; // Arrow Below - Top Right
	this.arrImgBbrFile = 'gray-arrow-bbr.gif'; // Arrow Below - Below Right
	this.arrImgRtlFile = 'gray-arrow-rtl.gif'; // Arrow Right - Top Left
	this.arrImgRblFile = 'gray-arrow-rbl.gif'; // Arrow Right - Below Left
	this.arrImgRtrFile = 'gray-arrow-rtr.gif'; // Arrow Right - Top right
	this.arrImgRbrFile = 'gray-arrow-rbr.gif'; // Arrow Right - Below Right
	this.tooltipWidth = 200;
	this.tooltipBgColor = '#5A5A5A'; // Color of the bckgrd tooltip
  this.colorTemplate = ''; // Templates : green:#2BA113 / blue:#002AB4 / pink:#B400AA / red:#B40000 / dodger:#0083B4 / gray:#5A5A5A
                           // lbue:#a4ceff / / turquoise:#a4ffff / lgreen:#c0ffa8 / lpink:#ffa4ff / lred:#ffa4a4
  this.customTemplate = ''; // Custom template ddicaced to one tag : template="color of the template"
                            // or Template ="color template,track(false or true),width of the tt,rounded corner size"
	this.closeMessage = 'Close';
	this.disableTooltipMessage = 'Don\'t show this message again';
	this.activeInput = false;
	this.tooltipPosition = 'right';
	this.arrowRightWidth = 16;			// Default width of arrow when the tooltip is on the right side of the inputs.
	this.arrowTopHeight = 13;			// Default height of arrow at the top of tooltip
	this.tooltipCornerSize = 10;
	this.displayArrow = true;
	this.cookieName = 'ec_tooltipVisibility';
	this.disableTooltipByCookie = false;
	this.tooltipDisabled = false;
	this.disableTooltipPossibility = true;
	this.tooltipIframeObj = false;
	this.pageBgColor = '#FFFFFF';
	ec_globalTooltipObj = this;
	if(navigator.userAgent.indexOf('MSIE')>=0)this.isMSIE = true; else this.isMSIE = false;
};

ec_formTooltip.prototype = {
    /**
     * Initializes the tooltip script. Most set methods needs to be executed before you call this method.
     * @public
     */
	initFormFieldTooltip : function()	{
	  var tagElements = [];
    if(this.limitedClass) {
  		var inputs = this.ec_getElementsByClass(this.limitedNode,this.limitedClass,this.limitedTag);
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)tagElements[tagElements.length] = inputs[no];
  		}
  	} else if(this.limitedId) {
      var inputs = document.getElementById(this.limitedId);
			var attr = inputs.getAttribute('tooltipText');
 			if(!attr)attr = inputs.tooltipText;
 			if(attr)tagElements[0] = inputs;
    } else {
  		var formElements = [];
  		var inputs = document.getElementsByTagName('INPUT');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)formElements[formElements.length] = inputs[no];
  		}
  		var inputs = document.getElementsByTagName('TEXTAREA');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)formElements[formElements.length] = inputs[no];
  		}
  		var inputs = document.getElementsByTagName('SELECT');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)formElements[formElements.length] = inputs[no];
  		}
  		var inputs = document.getElementsByTagName('DIV');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)tagElements[tagElements.length] = inputs[no];
  		}
  		var inputs = document.getElementsByTagName('SPAN');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)tagElements[tagElements.length] = inputs[no];
  		}
  		var inputs = document.getElementsByTagName('IMG');
  		for(var no=0;no<inputs.length;no++){
  			var attr = inputs[no].getAttribute('tooltipText');
  			if(!attr)attr = inputs[no].tooltipText;
  			if(attr)tagElements[tagElements.length] = inputs[no];
  		}
      for(var no=0;no<formElements.length;no++){
  			formElements[no].onfocus = this.__displayTooltip;
  		}
    }
		for(var no=0;no<tagElements.length;no++){
			tagElements[no].onmouseover = this.__displayTooltip;
			if (this.tooltipNoMove == undefined || this.tooltipNoMove.indexOf(tagElements[no].id)<0) {
			 tagElements[no].onmouseout = this.__hideTooltip;			
			 tagElements[no].onmousemove= this.__moveTooltip;
			} 
		}
		window.refToFormTooltip = this;
		this.addEvent(window,'resize',function(){window.refToFormTooltip.__positionCurrentToolTipObj();});
		this.addEvent(document.documentElement,'click',function(e){window.refToFormTooltip.__autoHideTooltip(e);});
	},
    /**
     * Specify a list of Ids for no move tooltips
     *	@param String list
     * @public
     */
	setTooltipNoMove : function(nomoveList) {
		this.tooltipNoMove = nomoveList;
	},	
    /**
     * Specify position of tooltip(below or right)
     *	@param String newPosition (Possible values: "below" or "right")
     * @public
     */
	setTooltipPosition : function(newPosition) {
		this.tooltipPosition = newPosition;
	},
    /**
     * Specify "Close" message
     *	@param String closeMessage
     * @public
     */
	setCloseMessage : function(closeMessage) {
		this.closeMessage = closeMessage;
	},
    /**
     * Specify disable tooltip message at the bottom of the tooltip
     *	@param String disableTooltipMessage
     * @public
     */
	setDisableTooltipMessage : function(disableTooltipMessage) {
		this.disableTooltipMessage = disableTooltipMessage;
	},
    /**
     * Specify whether you want the disable link to appear or not.
     *	@param Boolean disableTooltipPossibility
     * @public
     */
	setTooltipDisablePossibility : function(disableTooltipPossibility) {
		this.disableTooltipPossibility = disableTooltipPossibility;
	},
    /**
     * Specify name of cookie. Useful if you're using this script on several pages.
     *	@param String newCookieName
     * @public
     */
	setCookieName : function(newCookieName) {
		this.cookieName = newCookieName;
	},
    /**
     * Specify width of tooltip
     *	@param Int newWidth
     * @public
     */
	setTooltipWidth : function(newWidth) {
		this.tooltipWidth = newWidth;
	},
    /**
     * Display arrow at the top or at the left of the tooltip?
     *	@param Boolean displayArrow
     * @public
     */
	setArrowVisibility : function(displayArrow) {
		this.displayArrow = displayArrow;
	},
    /**
     * Send true to this method if you want to be able to save tooltip visibility in cookie. If it's set to true,
     *	It means that when someone returns to the page, the tooltips won't show.
     *	@param Boolean disableTooltipByCookie
     * @public
     */
	setDisableTooltipByCookie : function(disableTooltipByCookie) {
		this.disableTooltipByCookie = disableTooltipByCookie;
	},
    /**
     * This method specifies background color of tooltip
     *	@param String newBgColor
     * @public
     */
	setTooltipBgColor : function(newBgColor) {
		this.tooltipBgColor = newBgColor;
	},
     /**
     * Size of rounded corners around tooltip
     *	@param Int newSize (0 = no rounded corners)
     * @public
     */
	setTooltipCornerSize : function(tooltipCornerSize) {
		this.tooltipCornerSize = tooltipCornerSize;
	},
    /**
     * Size height of arrow at the top of tooltip
     *	@param Int arrowTopHeight
     * @public
     */
	setTopArrowHeight : function(arrowTopHeight) {
		this.arrowTopHeight = arrowTopHeight;
	},
    /**
     * Size width of arrow when the tooltip is on the right side of inputs
     *	@param Int arrowTopHeight
     * @public
     */
	setRightArrowWidth : function(arrowRightWidth) {
		this.arrowRightWidth = arrowRightWidth;
	},
    /**
     * Specify background color of page.
     *	@param String pageBgColor
     * @public
     */
	setPageBgColor : function(pageBgColor) {
		this.pageBgColor = pageBgColor;
	},
    /**
     * Specify limited area of the document.
     *	@param String LimitedId
     * @public
     */
	setToLimitedId : function(limitedId) {
		this.limitedId = limitedId;
	},
    /**
     * Specify limited Node Class & Tag
     * @param Node & Strings (Node and Tag are optionals)
     * @public
     */
	setToLimitedClass : function(searchNode, searchClass, searchTag) {
	  this.limitedNode = searchNode;
    this.limitedClass = searchClass;
    this.limitedTag = searchTag;

	},
    /**
     * Customize x & y offsets of tooltip
     *	@param integers
     * @public
     */
	setOffsetCursor : function(offsetfromcursorX,offsetfromcursorY) {
		this.offsetfromcursorX = offsetfromcursorX;
		this.offsetfromcursorY = offsetfromcursorY;
	},
    /**
     * Customize x & y offsets of tooltip
     *	@param integers
     * @public
     */
	setOffsetPointer : function(offsetdivfrompointerX,offsetdivfrompointerY) {
		this.offsetdivfrompointerX = offsetdivfrompointerX;
		this.offsetdivfrompointerY = offsetdivfrompointerY;
	},
    /**
     * Customize color of the tooltip by a template name
     *	@param String
     * @public
     */
	setColorTemplate : function(colorTemplate) {
	  // green:#2BA113 / blue:#002AB4 / pink:#B400AA / red:#B40000 / dodger:#0083B4 / gray:#5A5A5A / lbue:#a4ceff 
    // turquoise:#a4ffff / lgreen:#c0ffa8 /lpink:#ffa4ff / lred:#ffa4a4 / lgray:#c7c7c7
	  var templ = '2BA113green,002AB4blue,B400AApink,B40000red,0083B4dodger,5A5A5Agray,A4CEFFlblue,A4FFFFturquoise,C0FFA8lgreen,FFA4FFlpink,FFA4A4lred,C7C7C7lgray';
    var colortpl = colorTemplate.toLowerCase();
    var posColor = templ.search(colortpl);
	  if(posColor>0) {
	    this.colorTemplate = colortpl;
  	  this.tooltipBgColor = '#'+templ.substr((posColor-6),6);
    	this.arrImgBtlFile = colortpl+'-arrow-btl.gif'; // Below - Top Left
    	this.arrImgBblFile = colortpl+'-arrow-bbl.gif'; // Below - Below Left
    	this.arrImgBtrFile = colortpl+'-arrow-btr.gif'; // Below - Top Right
    	this.arrImgBbrFile = colortpl+'-arrow-bbr.gif'; // Below - Below Right
    	this.arrImgRtlFile = colortpl+'-arrow-rtl.gif'; // Right - Top Left
    	this.arrImgRblFile = colortpl+'-arrow-rbl.gif'; // Right - Below Left
    	this.arrImgRtrFile = colortpl+'-arrow-rtr.gif'; // Right - Top right
    	this.arrImgRbrFile = colortpl+'-arrow-rbr.gif'; // Right - Below Right
    }
	},
    /**
     * Set the files images path
     *	@param String
     * @public
     */
	setImagesPath : function(imagePath) {
    this.imagePath=imagePath.toLowerCase();
	},
    /**
     * This method displays the tooltip
     * @private
     */
	__displayTooltip : function() {
		if(ec_globalTooltipObj.disableTooltipByCookie){
			var cookieValue = ec_globalTooltipObj.getCookie(ec_globalTooltipObj.cookieName)+ '';
			if(cookieValue=='1')ec_globalTooltipObj.tooltipDisabled=true;
		}
		var noMove = (ec_globalTooltipObj.tooltipNoMove != undefined && ec_globalTooltipObj.tooltipNoMove.indexOf(this.id)>0);
		var ttToFreeze = (this.tagName.toLowerCase()=='input' || this.tagName.toLowerCase()=='textarea' || this.tagName.toLowerCase()=='select' || noMove );
		if(ec_globalTooltipObj.tooltipDisabled && ttToFreeze)return;	// Tooltip disabled
		var tooltipText = this.getAttribute('tooltipText');
		ec_globalTooltipObj.activeInput = this;
		if(!tooltipText)tooltipText = this.tooltipText;
		ec_globalTooltipObj.tooltipText = tooltipText;
		ec_globalTooltipObj.customTemplate = this.getAttribute('template');
		if(ec_globalTooltipObj.tooltipDiv) document.body.removeChild(ec_globalTooltipObj.tooltipDiv);
		var multiCustTemplate = false;
		if(ec_globalTooltipObj.customTemplate) {
		  var param = ec_globalTooltipObj.customTemplate.split(",");
		  if(param[0]!=ec_globalTooltipObj.customTemplate) {
        multiCustTemplate = true;
        ec_globalTooltipObj.customTemplate = param[0];
        var bckpttToFreeze = ttToFreeze;
        if(param[1]=="false" || param[1]=="true") ttToFreeze = eval(param[1]);
        if(ttToFreeze){this.onmouseout = null; this.onmousemove = null;}
        else {this.onmouseout = ec_globalTooltipObj.__hideTooltip; this.onmousemove = ec_globalTooltipObj.__moveTooltip;}  
        var bckpTooltipWidth = ec_globalTooltipObj.tooltipWidth;
        ec_globalTooltipObj.tooltipWidth = (param[2]!="" && isFinite(param[2]))?param[2]:ec_globalTooltipObj.tooltipWidth;
        var bckpCornerSize = ec_globalTooltipObj.tooltipCornerSize;
        ec_globalTooltipObj.tooltipCornerSize = (param[3]!="" && isFinite(param[3]))?param[3]:ec_globalTooltipObj.tooltipCornerSize;
        var bckpdisableTooltipPossibility = ec_globalTooltipObj.disableTooltipPossibility;
        if(param[3]=="false" || param[3]=="true") ec_globalTooltipObj.disableTooltipPossibility = eval(param[3]);
      }     
      var bckpTooltipBgColor = ec_globalTooltipObj.tooltipBgColor;      
		  var bckpColorTemplate = ec_globalTooltipObj.colorTemplate;		  
		  ec_globalTooltipObj.setColorTemplate(ec_globalTooltipObj.customTemplate);		  
      ec_globalTooltipObj.__createTooltip();
      ec_globalTooltipObj.tooltipBgColor = bckpTooltipBgColor;
		  ec_globalTooltipObj.colorTemplate = bckpColorTemplate;
		} else {		
      if(ec_globalTooltipObj.colorTemplate)ec_globalTooltipObj.setColorTemplate(ec_globalTooltipObj.colorTemplate);
      ec_globalTooltipObj.__createTooltip();
    }
		ec_globalTooltipObj.__positionTooltip(this);
    try{ // Catch IE errors
		  document.getElementById("ec_formTooltipCloseDiv").style.display=(ttToFreeze)?"block":"none";
		}catch(e){}
		ec_globalTooltipObj.tooltipContentDiv.innerHTML = tooltipText;
		ec_globalTooltipObj.tooltipDiv.style.display='block';
    if(multiCustTemplate) {
        ec_globalTooltipObj.tooltipWidth = bckpTooltipWidth;
        ec_globalTooltipObj.tooltipCornerSize = bckpCornerSize;
        ec_globalTooltipObj.disableTooltipPossibility = bckpdisableTooltipPossibility;        
    }
	},
    /**
     * This function hides the tooltip
     * @private
     */
	__hideTooltip : function() {
		try{
		  ec_globalTooltipObj.tooltipDiv.style.display='none';
			if(ec_globalTooltipObj.tooltipPosition=='below'){
        ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath + ec_globalTooltipObj.arrImgBtlFile+'?rand='+Math.random();
        ec_globalTooltipObj.topDiv.style.position = 'relative';
        ec_globalTooltipObj.topDiv.style.marginTop='0';
        ec_globalTooltipObj.arrowDiv.style.margin='0';
      } else ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath + ec_globalTooltipObj.arrImgRtlFile+'?rand='+Math.random();
      ec_globalTooltipObj.arrowDiv.style.margin="0";
		}catch(e){
		}
	},
    /**
     * Return the source of an event.
     * @private
     */
    getSrcElement : function(e) {
    	var el;
		  if (e.target) el = e.target;
			else if (e.srcElement) el = e.srcElement;
			if (el.nodeType == 3) // defeat Safari bug
				el = el.parentNode;
		  return el;
    },
	__autoHideTooltip : function(e) {
		if(document.all)e = event;
		var src = this.getSrcElement(e);
		if(src.tagName.toLowerCase()!='input' && src.tagName.toLowerCase().toLowerCase()!='textarea' && src.tagName.toLowerCase().toLowerCase()!='select')
		  if(src.tagName.toLowerCase()!='div' && src.tagName.toLowerCase().toLowerCase()!='span' && src.tagName.toLowerCase().toLowerCase()!='img')this.__hideTooltip();
		var attr = src.getAttribute('tooltipText');
		if(!attr)attr = src.tooltipText;
		if(!attr){
			this.__hideTooltip();
		}
	},
    /**
     * This function hides the tooltip
     * @private
     */
	__hideTooltipFromLink : function() {
		this.activeInput.focus();
		window.refToThis = this;
		setTimeout('window.refToThis.__hideTooltip()',10);
	},
    /**
     * Hide tooltip and disable it
     * @public
     */
	disableTooltip : function() {
		this.__hideTooltipFromLink();
		if(this.disableTooltipByCookie)this.setCookie(this.cookieName,'1',500);
		this.tooltipDisabled = true;
	},
    /**
     * This function creates the tooltip elements
     * @private
     */
	__createTooltip : function() {
		this.tooltipDiv = document.createElement('DIV');
		this.tooltipDiv.id = 'ec_formTooltip';
		this.tooltipDiv.style.position = 'absolute';
		this.tooltipDiv.style.zIndex = '9999';
		if(this.displayArrow){
			this.topDiv = document.createElement('DIV');
			if(this.tooltipPosition=='below'){
				this.topDiv.style.marginLeft = '20px';
				this.arrowDiv = document.createElement('IMG');
				this.arrowDiv.id = 'ec_formTooltipArrow';
				this.arrowDiv.src = this.imagePath + this.arrImgBtlFile + '?rand='+ Math.random();
				this.arrowDiv.style.display='block';
				this.topDiv.appendChild(this.arrowDiv);
			}else{
				this.topDiv.style.marginTop = '5px';
				this.arrowDiv = document.createElement('IMG');
				this.arrowDiv.id = 'ec_formTooltipArrow';				
				this.arrowDiv.src = this.imagePath + this.arrImgRtlFile + '?rand='+ Math.random();
				this.arrowDiv.style.display='block';
				this.topDiv.appendChild(this.arrowDiv);
				this.topDiv.style.position = 'absolute';
			}
			this.tooltipDiv.appendChild(this.topDiv);
		}
		var outerDiv = document.createElement('DIV');
		outerDiv.style.position = 'relative';
		outerDiv.style.zIndex = 1000;
		if(this.tooltipPosition!='below' && this.displayArrow){
			outerDiv.style.left = this.arrowRightWidth + 'px';
		}
		outerDiv.id = 'ec_formTooltipDiv';
		outerDiv.className = 'ec_formTooltipDiv';
		outerDiv.style.backgroundColor = this.tooltipBgColor;
		this.tooltipDiv.appendChild(outerDiv);
		this.tooltipContentDiv = document.createElement('DIV');
		this.tooltipContentDiv.style.position = 'relative';
		this.tooltipContentDiv.id = 'ec_formTooltipContent';
		outerDiv.appendChild(this.tooltipContentDiv);
		var closeDiv = document.createElement('DIV');
		closeDiv.id = 'ec_formTooltipCloseDiv';
		closeDiv.style.textAlign = 'center';
		closeDiv.innerHTML = '<A class="ec_formTooltip_closeMessage" href="#" onclick="ec_globalTooltipObj.__hideTooltipFromLink();return false">' + this.closeMessage + '</A>';
		if(this.disableTooltipPossibility){
			var tmpHTML = closeDiv.innerHTML;
			tmpHTML = tmpHTML + ' | <A class="ec_formTooltip_closeMessage" href="#" onclick="ec_globalTooltipObj.disableTooltip();return false">' + this.disableTooltipMessage + '</A>';
			closeDiv.innerHTML = tmpHTML;
 		}
 		outerDiv.appendChild(closeDiv);
		document.body.appendChild(this.tooltipDiv);
		if(this.tooltipCornerSize>0){
			this.roundedCornerObj = new ec_roundedCorners();
			// (divId,xRadius,yRadius,color,backgroundColor,padding,heightOfContent,whichCorners)
			this.roundedCornerObj.addTarget('ec_formTooltipDiv',this.tooltipCornerSize,this.tooltipCornerSize,this.tooltipBgColor,this.pageBgColor,5);
			this.roundedCornerObj.init();
		}
		this.tooltipContentDiv = document.getElementById('ec_formTooltipContent');
	},
	addEvent : function(obj,type,fn){
    if(obj.addEventListener) obj.addEventListener(type,fn,false);
    else if(obj.attachEvent){
        obj["e"+type+fn]=fn;
        obj[type+fn]=function(){obj["e"+type+fn](window.event);}
        obj.attachEvent("on"+type,obj[type+fn]);
    }
	},
	__positionCurrentToolTipObj : function() {
		  if(ec_globalTooltipObj.activeInput)this.__positionTooltip(ec_globalTooltipObj.activeInput);
	},
    /**
     * This function positions the tooltip
     * @param Obj inputObj = Reference to text input
     * @private
     */
	__positionTooltip : function(inputObj) {
	 //if(!(!this.isMSIE && this.activeInput.tagName.toLowerCase()=='input' || this.activeInput.tagName.toLowerCase()=='textarea' || this.activeInput.tagName.toLowerCase()=='select')) return;
		var offset = 0;
		if(!this.displayArrow)offset = 3;
		if(this.tooltipPosition=='below'){
			this.tooltipDiv.style.left = this.getLeftPos(inputObj)+ 'px';
			this.tooltipDiv.style.top = (this.getTopPos(inputObj) + inputObj.offsetHeight + offset) + 'px';
		}else{
    	this.tooltipDiv.style.left = (this.getLeftPos(inputObj) + inputObj.offsetWidth + offset)+ 'px';
			this.tooltipDiv.style.top = this.getTopPos(inputObj) + 'px';
		}
		this.tooltipDiv.style.width=this.tooltipWidth + 'px';
	},
  __reverseToolTip : function(zonediv) {
  try { // Catch IE errors
    if(ec_globalTooltipObj.displayArrow){
      if(ec_globalTooltipObj.tooltipPosition=='below'){
        if(zonediv=='LeftTop'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgBtlFile+'?rand='+ Math.random();
          ec_globalTooltipObj.topDiv.style.position = 'relative';
          ec_globalTooltipObj.topDiv.style.marginTop="0";
          ec_globalTooltipObj.arrowDiv.style.margin="0";
        } else if(zonediv=='RightTop'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgBtrFile+'?rand='+ Math.random();
          ec_globalTooltipObj.topDiv.style.position = 'relative';
          ec_globalTooltipObj.arrowDiv.style.margin="0";
          ec_globalTooltipObj.arrowDiv.style.marginLeft=parseInt(2*ec_globalTooltipObj.tooltipDiv.offsetWidth/3)+"px";
        } else if(zonediv=='LeftBottom'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgBblFile+'?rand='+ Math.random();
          ec_globalTooltipObj.arrowDiv.style.margin="0";
          ec_globalTooltipObj.topDiv.style.position = 'absolute';
          ec_globalTooltipObj.topDiv.style.marginTop=ec_globalTooltipObj.tooltipDiv.offsetHeight+"px";
        } else { // RightBottom
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgBbrFile+'?rand='+ Math.random();
          ec_globalTooltipObj.topDiv.style.position = 'absolute';
          ec_globalTooltipObj.topDiv.style.marginTop=ec_globalTooltipObj.tooltipDiv.offsetHeight+"px";
          ec_globalTooltipObj.arrowDiv.style.marginLeft=parseInt(2*ec_globalTooltipObj.tooltipDiv.offsetWidth/3)+"px";
        }
      } else {
        if(zonediv=='LeftTop'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgRtlFile+'?rand='+ Math.random();
          ec_globalTooltipObj.arrowDiv.style.margin="0";          
        } else if(zonediv=='RightTop'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgRtrFile+'?rand='+ Math.random();
          ec_globalTooltipObj.arrowDiv.style.margin="0";
          ec_globalTooltipObj.arrowDiv.style.marginLeft=ec_globalTooltipObj.tooltipDiv.offsetWidth+ec_globalTooltipObj.arrowRightWidth+"px";
        } else if(zonediv=='LeftBottom'){
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgRblFile+'?rand='+ Math.random();
          ec_globalTooltipObj.arrowDiv.style.marginLeft="0";
          ec_globalTooltipObj.arrowDiv.style.marginTop=document.getElementById("ec_formTooltip").offsetHeight-2.2*ec_globalTooltipObj.arrowTopHeight+"px";
        } else { // RightBottom
          ec_globalTooltipObj.arrowDiv.src= ec_globalTooltipObj.imagePath+ec_globalTooltipObj.arrImgRbrFile+'?rand='+ Math.random();
          ec_globalTooltipObj.arrowDiv.style.margin="0";
          ec_globalTooltipObj.arrowDiv.style.marginLeft=ec_globalTooltipObj.tooltipDiv.offsetWidth+ec_globalTooltipObj.arrowRightWidth+"px";
          ec_globalTooltipObj.arrowDiv.style.marginTop=(ec_globalTooltipObj.tooltipDiv.offsetHeight-2.2*ec_globalTooltipObj.arrowTopHeight)+"px";
        }
      }
    }
  } catch(e) {
  }
  },
    /**
     * This function move the tooltip
     * @private
     */
	__moveTooltip : function(e) {
	  //if(!document.body.tooltipDiv)return;
    try {	 // Catch IE errors
    var ie=document.all;
    var ns6=document.getElementById && !document.all;
    var tipobj=ec_globalTooltipObj.tooltipDiv; //document.all? document.all["ec_formTooltip"] : document.getElementById? document.getElementById("ec_formTooltip") : "";
    var ietruebody = (document.compatMode && document.compatMode!="BackCompat")? document.documentElement : document.body;
    var curX=(ns6)?e.pageX : event.clientX+ietruebody.scrollLeft;
    var curY=(ns6)?e.pageY : event.clientY+ietruebody.scrollTop;
    if(ie&&!window.opera) {
      var winwidth=ietruebody.clientWidth;
      var winheight=ietruebody.clientHeight;
      var rightedge=winwidth-event.clientX-ec_globalTooltipObj.offsetfromcursorX;
      var bottomedge=winheight-event.clientY-ec_globalTooltipObj.offsetfromcursorY;
    } else {
      var winwidth=window.innerWidth-20;
      var winheight=window.innerHeight-20;
      var rightedge=winwidth-e.clientX-ec_globalTooltipObj.offsetfromcursorX;
      var bottomedge=winheight-e.clientY-ec_globalTooltipObj.offsetfromcursorY;
    }
    var leftedge=(ec_globalTooltipObj.offsetfromcursorX<0)? ec_globalTooltipObj.offsetfromcursorX*(-1) : -1000;
    //Zone of the DIV near RIGHT boder of the window
    if (rightedge<tipobj.offsetWidth){
      //Zone of the DIV near LOW boder of the window
      if (bottomedge<tipobj.offsetHeight){
        ec_globalTooltipObj.__reverseToolTip('RightBottom');
        tipobj.style.top=curY-tipobj.offsetHeight-ec_globalTooltipObj.offsetfromcursorY+"px";
      }else{
        ec_globalTooltipObj.__reverseToolTip('RightTop');
        tipobj.style.top=curY+ec_globalTooltipObj.offsetfromcursorY+"px";
      }
      //move the horizontal position of the menu to the left by it's width
      tipobj.style.left=curX-tipobj.offsetWidth-ec_globalTooltipObj.arrowRightWidth-ec_globalTooltipObj.offsetfromcursorX-1.5*ec_globalTooltipObj.offsetdivfrompointerX+"px";
    }
    //Zone of the DIV near LEFT boder of the window
    else if (curX<leftedge)
      tipobj.style.left="5px";
    else{
      //Zone of the DIV near LOW boder of the window
      if (bottomedge<tipobj.offsetHeight){
        ec_globalTooltipObj.__reverseToolTip('LeftBottom');
        tipobj.style.top=curY-tipobj.offsetHeight-ec_globalTooltipObj.offsetfromcursorY+"px";
      } else{
        ec_globalTooltipObj.__reverseToolTip('LeftTop');
        tipobj.style.top=curY+ec_globalTooltipObj.offsetfromcursorY+"px";
      }
      //position the horizontal position of the menu where the mouse is positioned
      tipobj.style.left=curX+ec_globalTooltipObj.offsetfromcursorX+ec_globalTooltipObj.offsetdivfrompointerX+"px";
    }
  } catch(e) {
  }
	},
    /**
     * This method will return the top coordinate(pixel) of an object
     * @param Object inputObj = Reference to HTML element
     * @public
     */
	getTopPos : function(inputObj) {
	  var returnValue = inputObj.offsetTop;
	  while((inputObj = inputObj.offsetParent) != null){
	  	if(inputObj.tagName!='HTML'){
	  		returnValue += inputObj.offsetTop;
	  		if(document.all)returnValue+=inputObj.clientTop;
	  	}
	  }
	  return returnValue;
	},
    /**
     * This method will return the left coordinate(pixel) of an object
     * @param Object inputObj = Reference to HTML element
     * @public
     */
	getLeftPos : function(inputObj) {
	  var returnValue = inputObj.offsetLeft;
	  while((inputObj = inputObj.offsetParent) != null){
	  	if(inputObj.tagName!='HTML'){
	  		returnValue += inputObj.offsetLeft;
	  		if(document.all)returnValue+=inputObj.clientLeft;
	  	}
	  }
	  return returnValue;
	},
    /**
     * 	These cookie functions are downloaded from
  	 * 	http://www.mach5.com/support/analyzer/manual/html/General/CookiesJavaScript.htm
     * This function returns the value of a cookie
     * @param String name = Name of cookie
     * @param Object inputObj = Reference to HTML element
     * @public
     */
	getCookie : function(name) {
	   var start = document.cookie.indexOf(name+"=");
	   var len = start+name.length+1;
	   if ((!start) && (name != document.cookie.substring(0,name.length))) return null;
	   if (start == -1) return null;
	   var end = document.cookie.indexOf(";",len);
	   if (end == -1) end = document.cookie.length;
	   return unescape(document.cookie.substring(len,end));
	},
    /**
     * 	These cookie functions are downloaded from
  	 * 	http://www.mach5.com/support/analyzer/manual/html/General/CookiesJavaScript.htm
     * This function creates a cookie. (This method has been slighhtly modified)
     * @param String name = Name of cookie
     * @param String value = Value of cookie
     * @param Int expires = Timestamp - days
     * @param String path = Path for cookie (Usually left empty)
     * @param String domain = Cookie domain
     * @param Boolean secure = Secure cookie(SSL)
     * @public
     */
	setCookie : function(name,value,expires,path,domain,secure) {
		expires = expires * 60*60*24*1000;
		var today = new Date();
		var expires_date = new Date( today.getTime()+(expires) );
	    var cookieString = name+"=" +escape(value) +
	       ( (expires) ? ";expires="+expires_date.toGMTString() : "") +
	       ( (path) ? ";path="+path : "") +
	       ( (domain) ? ";domain="+domain : "") +
	       ( (secure) ? ";secure" : "");
	    document.cookie = cookieString;
	},
  /**
   * Get the list of elements of the page by the name of the class
   * @public
   */
  ec_getElementsByClass : function(searchNode,searchClass,searchTag) {
  	var classElements = [];
  	if (searchNode==null)searchNode = document;
  	if (searchTag==null)searchTag = '*';
  	var els = searchNode.getElementsByTagName(searchTag);
  	var pattern = new RegExp("(^|\\s)"+searchClass+"(\\s|$)");
  	for (i = 0, j = 0; i < els.length; i++) {
  		if ( pattern.test(els[i].className) ) {
  			classElements[j] = els[i];
  			j++;
  		}
  	}
  	return classElements;
  }
};
